#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "types.h"


static expr id( char *s ) { return expr_id( strdup(s) ); }

int main( void )
{
	guard g0 = guard_pair(
		bexpr_binop( id("x"), boolop_gt(), expr_num(7) ),
		id("second") );
	guardlist gl = guardlist_nil();
	gl = guardlist_push( gl, g0 );
	printf( "1-element guardlist: " );
	print_guardlist( stdout, gl );
	printf( "\n" );
	//exit(0);

	guard g1 = guard_pair( 
		bexpr_binop( id("x"), boolop_gt(), expr_num(17) ),
		id( "first" ) );
	gl = guardlist_cons( g1, gl );
	printf( "2-element guardlist: " );
	print_guardlist( stdout, gl );
	printf( "\n" );

	guard g2 = guard_pair( bexpr_truev(), id( "third" ) );
	gl = guardlist_push( gl, g2 );
	printf( "3-element guardlist: " );
	print_guardlist( stdout, gl );
	printf( "\n" );

	free_guardlist( gl );

	return 0;
}
